"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

var callAction = _interopRequire(require("./callAction"));

var INTROSPECTION_TYPE = require("./types").INTROSPECTION_TYPE;

var notFoundValue = _interopRequire(require("./notFoundValue"));

module.exports = function (_ref) {
  var resources = _ref.resources;
  var states = _ref.states;
  return function (_ref2) {
    var actionSetID = _ref2.actionSetID;
    return function (_ref3) {
      var introspectionID = _ref3.introspectionID;
      var payload = _ref3.payload;
      var combine = _ref3.combine;
      var _ref3$booleanOr = _ref3.booleanOr;
      var booleanOr = _ref3$booleanOr === undefined ? false : _ref3$booleanOr;
      var _ref3$booleanAnd = _ref3.booleanAnd;
      var booleanAnd = _ref3$booleanAnd === undefined ? false : _ref3$booleanAnd;

      if (booleanOr) {
        combine = function (combined, current) {
          return combined || current;
        };
      } else if (booleanAnd) {
        combine = function (combined, current) {
          return combined && current;
        };
      }

      var combinedValue = Object.keys(resources).reduce(function (combinedValue, resourceID, i) {
        var _resources$resourceID = resources[resourceID];
        var reducer = _resources$resourceID.reducer;
        var props = _resources$resourceID.props;

        var currentValue = callAction({
          responder: reducer,
          type: INTROSPECTION_TYPE,
          initialValue: states[resourceID],
          props: props,
          actionID: introspectionID,
          actionSetID: actionSetID,
          payload: payload,
          notFoundValue: notFoundValue
        });

        if (currentValue !== notFoundValue) {
          if (combinedValue === notFoundValue) {
            return currentValue;
          } else {
            return combine(combinedValue, currentValue);
          }
        }

        return combinedValue;
      }, notFoundValue);

      if (combinedValue !== notFoundValue) {
        return combinedValue;
      }
    };
  };
};